/**************************************************************************
 *                                                                        *
 *   Copyright (c) Digital Equipment  Corporation,  1991.   All  Rights   *
 *   Reserved.  Unpublished rights reserved under the copyright laws of   *
 *   the United States.                                                   *
 *                                                                        *
 *   The software  contained  on  this  media  is  proprietary  to  and   *
 *   embodies   the   confidential   technology  of  Digital  Equipment   *
 *   Corporation.  Possession, use, duplication or dissemination of the   *
 *   software  and media is authorized only pursuant to a valid written   *
 *   license from Digital Equipment Corporation.                          *
 *                                                                        *
 *   RESTRICTED RIGHTS LEGEND Use, duplication, or  disclosure  by  the   *
 *   U.S.   Government  is  subject  to  restrictions  as  set forth in   *
 *   Subparagraph  (c)(1)(ii)  of  DFARS  252.227-7013,   or   in   FAR   *
 *   52.227-19, as applicable.                                            *
 *                                                                        *
 **************************************************************************/
#ifdef SCCS
static char sccsid[]="@(#)multi_hog.c	5.1 Stardent 91/05/03";
#endif
/*
			Copyright (c) 1989 by
			Stardent Computer Inc.
			All Rights Reserved
	
	This software comprises unpublished confidential information of
	Stardent Computer Inc. and may not be used, copied or made
	available to anyone, except in accordance with the license
	under which it is furnished.
	
	This file is under sccs control at Stardent in:
	/sccs3.p/avs/examples/s.multi_hog.c
*/
/*
			Copyright (c) 1989 by
			Stardent Computer Inc.
			All Rights Reserved
	
	This software comprises unpublished confidential information of
	Stardent Computer Inc. and may not be used, copied or made
	available to anyone, except in accordance with the license
	under which it is furnished.
	
	This file is under sccs control at Stardent in:
	@uranus/sccs1.p/avs/modules/link/s.mod_inits.c
*/
#include <avs/avs.h>
#include <avs/flow.h>

/*-------------------------------------------------------------------------
 *
 * Introduction:	
 *
 *	Suppose you constructed a network with several connected
 *	modules on a remote host:
 *
 *	
 *			read field			}
 *			    |				}
 *		+-----------+-----------+		}
 *		|			|		}
 *	compute gradient		|		}   on remote host
 *		|		volume bounds		}
 *	     hedgehog			|		}
 *		|			|		}
 *		+-----------+-----------+
 *			    |
 *			render geometry			}
 *			    |				}    on workstation
 *			display pixmap			}
 *
 *
 *	To reduce the communications overhead, number of processes, and
 *	amount of memory, AVS allows several modules to be linked together
 *	into a single executable.
 *
 *	On some platforms, all of the external AVS modules are shipped
 *	as libraries so you can link any combination of the standard 
 *	AVS modules and your own.
 *
 *	To be eligible to run in the same process as another module,
 *	the COOPERATIVE flag must be set.  Read the manuals for all
 *	the details.
 *
 *
 *------------------------------------------------------------------------*/

/*
 * initialization for modules contained in this file.
 */

/****************************************/
/* Data Modules                         */
/****************************************/
extern int 
  MODboolean(),
  MODbrowser(),
  MODcolor_range(),
  MODeuler(),
  MODfloat(),
  MODinteger(),
  MODoneshot(),
  MODpdb_to_geom(),
  MODread_field(),
  MODread_geom(),
  MODread_image(),
  MODread_volume(),
  MODsamplers(),
  MODstring(),
  MODtristate(),
  MODwrite_field();

/****************************************/
/* Filter Modules                       */
/****************************************/
extern int 
  MODantialias(),  
  MODbackground(),
  MODclamp(),
  MODcolorizer(),
  MODcombine(),
  MODcomposite(),
  MODcompute_gradient(),
  MODcontrast(),
  MODconvolve(), 
  MODcrop(),
  MODcurl(),
  MODdiv(),
  MODdownsize(),
  MODextract(),
  MODextract_vector(),
  MODfield_math(),
  MODfield_to_char(),
  MODfield_to_int(),
  MODfield_to_float(),
  MODfield_to_double(),
  MODfilters(),
  MODflip(),
  MODgenerate_histogram(),
  MODgrad(),
  MODgradient_shade(),
  MODhistr(),
  MODimage_compare(),
  MODinterpolate(),
  MODlocal_area(),
  MODluminence(),  
  MODmag(),
  MODmirror(),
  MODnormalize(),
  MODoffset(),
  MODreplace_alpha(),  
  MODshrink(),
  MODsobel(),
  MODthreshold(),
  MODtranspose(),
  MODwire(),
  MODtube();

/****************************************/
/* Mapper Modules                       */
/****************************************/
extern int 
  MODarbitrary_slicer(),
  MODbounds(),
  MODbrick(),
  MODbubbleviz(),
  MODfield_to_mesh(),
  MODhedgehog(),
  MODortho_slice(),
  MODscatter_dots(),
  MODstream_lines(),
  MODthresholded_slicer(),
  MODprobe(),
  MODcontour_to_geom();  

/****************************************/
/* Renderer Modules                     */
/****************************************/
extern int 
  MODcompare_field(),
  MODprint_field(),
  MODstatistics();


/****************************************/
/* Module List                          */
/****************************************/
int ((*mapper_mod_list[])()) = {
#if 0
    MODboolean,                        /* Data */
    MODbrowser,
    MODcolor_range,
    MODeuler,
    MODfloat,
    MODinteger,
    MODoneshot,
    MODpdb_to_geom,
#endif
    MODread_field,
#if 0
    MODread_geom,
    MODread_image,
    MODread_volume,
    MODsamplers,
    MODstring,
    MODtristate,
    MODwrite_field,
    
    MODantialias,                      /* Filters */
    MODbackground,
    MODclamp,
    MODcolorizer,
    MODcombine, 
    MODcomposite,
#endif
    MODcompute_gradient,
#if 0
    MODcontrast,
    MODconvolve, 
    MODcrop,
    MODcurl,
    MODdiv,
    MODdownsize,
    MODextract,
    MODextract_vector,
    MODfield_math,
    MODfield_to_char,
    MODfield_to_int,
    MODfield_to_float,
    MODfield_to_double,
    MODfilters,
    MODflip,
    MODgenerate_histogram,
    MODgrad,
    MODgradient_shade,
    MODhistr,
    MODimage_compare,
    MODinterpolate,
    MODlocal_area,
    MODluminence,  
    MODmag,
    MODmirror,
    MODnormalize,
    MODoffset,
    MODreplace_alpha,  
    MODshrink,
    MODsobel,
    MODthreshold,
    MODtranspose,
    MODwire,
    MODtube,

    MODarbitrary_slicer,               /* Mappers */
#endif
    MODbounds,
#if 0
    MODbrick,
    MODbubbleviz,
    MODfield_to_mesh,
#endif
    MODhedgehog,
#if 0
    MODortho_slice,
    MODscatter_dots,
    MODstream_lines,
    MODthresholded_slicer,
    MODprobe,
    MODcontour_to_geom,

    MODcompare_field,                            /* Renderers */
    MODprint_field,
    MODstatistics
#endif

};

#define NMODS sizeof(mapper_mod_list) / sizeof(char *) 

AVSinit_modules ()
{
	AVSinit_from_module_list(mapper_mod_list, NMODS);
}
